//---------------------------------------------------------------------------------------------
// atol_gui (C) 2005, Alexander G. Karpov [mrhx]
// based on ATOL v0.9
//---------------------------------------------------------------------------------------------
// VERSION: 0.5
//---------------------------------------------------------------------------------------------
#include "atol_interface.h"
#include "defs.h"
#include "common.cpp"
#include "props.cpp"
#include "utils.cpp"
#include "layout.cpp"
#include "wnd.cpp"
#include "controls.cpp"
#include "std_controls.cpp"
#include "ex_controls.cpp"
#include "msgbox.cpp"

/******************* EXTERNAL *******************************************************/

ATOL_API(cl)		// close current window.
// gui.close
{
	SendMessage((HWND) f(get_context)("atol_gui:wnd"), WM_CLOSE, 0, 0);
	return f(null)();
}

ATOL_API(run)		// run interface.
// gui.run
{
	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return f(atomi)(msg.wParam); // return code.
}

ATOL_API(capt)		// get caption.
// gui.caption( wnd [new_caption] )
{
	int n = check_args(IAtol, args, 1, 2, "caption");
	HWND hwnd = (HWND) f(atoi)(f(obj_prop)(f(list_item)(args), "handle"));

	int len = 1 + GetWindowTextLength(hwnd);
	char *buf = (char *) LocalAlloc(LMEM_FIXED, len);
	f(error)(!buf, "atol_gui: could not allocate memory");

	GetWindowText(hwnd, buf, len);
	ATOL_ATOM res = f(atom)(buf);

	LocalFree((HLOCAL) buf);

	if (n == 2) SetWindowText(hwnd, f(list_get)(args, 1));
	return res;
}
