//------------------------------------------------------------------
// INCLUDED FILE.
//------------------------------------------------------------------
// This contents common functions to support controls.
//------------------------------------------------------------------

HWND AddControl(ATOL_INTERFACE IAtol, char *Class, char *Caption, DWORD Style, int cx, int cy, DWORD ExStyle = 0);

// Add a control with a single line of text:
HWND AddSingleLineControl(ATOL_INTERFACE IAtol, char *Class, char *Caption, DWORD Style, DWORD ExStyle = 0)
{
	HWND hParent = GetCurrentWnd(IAtol);
	SIZE sz;
	HDC hdc = GetDC(hParent);
	SelectObject(hdc, (HFONT) SendMessage(hParent, WM_GETFONT, 0, 0));
	GetTextExtentPoint32(hdc, Caption, lstrlen(Caption), &sz);
	ReleaseDC(hParent, hdc);
	return AddControl(IAtol, Class, Caption, Style, sz.cx + BDX*2, sz.cy + BDY*2, ExStyle);
}

// Add a control with sizes in characters:
HWND AddCharSizedControl(ATOL_INTERFACE IAtol, char *Class, char *Caption, DWORD Style, int cx, int cy, DWORD ExStyle = 0)
{
	register long l = GetDialogBaseUnits();
	return AddControl(IAtol, Class, Caption, Style,
				cx * LOWORD(l) + 2*BDX, cy * HIWORD(l) + 2*BDY, ExStyle);
}

HWND AddControl(ATOL_INTERFACE IAtol, char *Class, char *Caption, DWORD Style, int cx, int cy, DWORD ExStyle)
{
	HWND hParent = GetCurrentWnd(IAtol);
	f(error)(!hParent, "No window to add a control to");

	int x, y;
	f(error)(!GetCtrlCoordinates(IAtol, hParent, cx, cy, &x, &y), "There is no more free space on the window to put a control on");

	HWND hCtrl = CreateWindowEx(ExStyle, Class, Caption,
						Style | WS_CHILD | WS_VISIBLE,
						x, y, cx, cy, hParent, NULL,
						GetModuleHandle(NULL), NULL);

	f(error)(!hCtrl, "atol_gui: Could not create a control");

	SendMessage(hCtrl, WM_SETFONT, GetWindowLong(hParent, WNDX_FONT), TRUE);

	return hCtrl;
}

/******************* EXTERNAL *******************************************************/

