//------------------------------------------------------------------
// INCLUDED FILE.
//------------------------------------------------------------------
// This contents functions to layout controls on the form.
//------------------------------------------------------------------

int __fastcall GetParam(ATOL_INTERFACE IAtol, char *Name, int DefValue = 0)
{
	register ATOL_ATOM param = f(atom)(Name);
	register int value = (int) f(get_context_atom)(param);
	f(set_context_atom)(param, NULL);
	return value?value:DefValue;
}

int __fastcall GetWidth(ATOL_INTERFACE IAtol, int DefWidth = 0)
{
	return GetParam(IAtol, "atol_gui:width", DefWidth);
}

int __fastcall GetHeight(ATOL_INTERFACE IAtol, int DefHeight = 0)
{
	return GetParam(IAtol, "atol_gui:height", DefHeight);
}

int __fastcall GetX(ATOL_INTERFACE IAtol, int DefX = 0)
{
	return GetParam(IAtol, "atol_gui:pos_x", DefX);
}

int __fastcall GetY(ATOL_INTERFACE IAtol, int DefY = 0)
{
	return GetParam(IAtol, "atol_gui:pos_y", DefY);
}

int CanPut(HWND hParent, POINT *ppt, int cx, int cy)
{
	POINT pt;
	int m_x = ppt->x + cx;
	int m_y = ppt->y + cy;

	for (pt.y = ppt->y; pt.y < m_y; pt.y += DY)
		for (pt.x = ppt->x; pt.x < m_x; pt.x += DX)
		{
			register HWND hwnd = ChildWindowFromPoint(hParent, pt);
			if (!hwnd || hwnd != hParent) return 0;
		}
	return 1;
}

int GetCtrlCoordinates(ATOL_INTERFACE IAtol, HWND hParent, int cx, int cy, int *px, int *py)
{
	POINT pt;
	int dy, dx, mn;
	RECT rc, rcChild;
	HWND hWnd;
	GetClientRect(hParent, &rc);
	for (pt.y = DY; pt.y < rc.bottom; pt.y += dy)
	{
		mn = rc.bottom;

		for (pt.x = DX; pt.x < rc.right; pt.x += dx)
		{
			hWnd = ChildWindowFromPoint(hParent, pt);
			if (hWnd && hWnd != hParent) // a child window.
			{
				GetClientRect(hWnd, &rcChild);
				dx = DX + rcChild.right;

				if (rcChild.bottom < mn) mn = rcChild.bottom; // calc min height.
			}
			else
			{
				if (CanPut(hParent, &pt, cx, cy))
				{
					*px = pt.x;
					*py = pt.y;
					return 1;
				}
				dx = DX;
			}
		}

		if (mn == rc.bottom) dy = DY; else dy = mn + DY;
	}

	return 0;
}

ATOL_ATOM __fastcall SetParam(ATOL_INTERFACE IAtol, ATOL_LIST args, char *name, char *param)
{
	check_args(IAtol, args, 1, name);
	register ATOL_STRING ptr = f(list_item)(args);
	if ()
	f(set_context)(param, (void *) f(atoi)());
	return f(list_item_atom)(args);
}

/******************* EXTERNAL *******************************************************/

ATOL_API(wid)		// set width.
// gui.width(+Width)
{
	return SetParam(IAtol, args, "width", "atol_gui:width");
}

ATOL_API(hei)		// set height.
// gui.height(+Height)
{
	return SetParam(IAtol, args, "height", "atol_gui:height");
}

ATOL_API(posx)		// set x.
// gui.x(+X)
{
	return SetParam(IAtol, args, "x", "atol_gui:pos_x");
}

ATOL_API(posy)		// set y.
// gui.y(+Y)
{
	return SetParam(IAtol, args, "y", "atol_gui:pos_y");
}
